%global __strip %{_mingw32_strip}
%global __objdump %{_mingw32_objdump}
%global _use_internal_dependency_generator 0
%global __find_requires %{_mingw32_findrequires}
%global __find_provides %{_mingw32_findprovides}
%define __debug_install_post %{_mingw32_debug_install_post}

# reset patch fuzz, rebasing patches will require delicate surgery -- Rex
%global _default_patch_fuzz 2

Name:    mingw32-openjpeg
Version: 1.3
Release: 5%{?dist}
Summary: MinGW Windows openjpeg library

Group:     Development/Libraries
License:   BSD
URL:       http://www.openjpeg.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch

BuildRequires: cmake

BuildRequires: mingw32-filesystem >= 52
BuildRequires: mingw32-gcc
BuildRequires: mingw32-binutils
BuildRequires: mingw32-libtiff

Source0: http://www.openjpeg.org/openjpeg_v1_3.tar.gz

# Patches from native Fedora package:
Patch1: openjpeg-20070717svn-codec-libtiff.patch
Patch4: openjpeg-svn480-cmake.patch
Patch5: openjpeg-svn480-use-stdbool.patch
Patch6: openjpeg-1.3-tcd_init_encode-alloc-fix.patch
Patch7: openjpeg-1.3-reverse-bogus-aligned-malloc.patch
Patch44: openjpeg-svn468-mj2-noscroll.patch
Patch21: openjpeg-20070717svn-mqc-optimize.patch
Patch22: openjpeg-20070821svn-t1-remove-macro.patch
Patch23: openjpeg-20070719svn-t1-x86_64-flags-branchless.patch
Patch24: openjpeg-20070719svn-t1-t1_dec_sigpass_step-optimize.patch
Patch25: openjpeg-20070821svn-t1-flags-stride.patch
Patch26: openjpeg-20070821svn-t1-updateflags-x86_64.patch
Patch27: openjpeg-svn470-t1-flags-mmx.patch
Patch28: openjpeg-20070719svn-mqc-more-optimize.patch

# libopenjpeg has undefined references, http://bugzilla.redhat.com/467661
Patch50: openjpeg-1.3-libm.patch

# Patches for MinGW:
Patch1000: openjpeg-1.3-mingw32-cmake.patch


%description
%{_mingw32_description}


%{_mingw32_debug_package}


%prep
%setup -q -n OpenJPEG_v1_3
# Make sure we use system libraries
rm -rf libs
%patch1 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch44 -p1
%patch22 -p1
%patch23 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch24 -p1
%patch21 -p1
%patch28 -p1
%patch50 -p1 -b .libm

%patch1000 -p1

# Fix permissions
chmod a-x ChangeLog license.txt


%build
mkdir build
pushd build
export MINGW32_CFLAGS="%{_mingw32_cflags} -DWIN32"
%{_mingw32_cmake} ..
make %{?_smp_mflags}
popd


%install
rm -rf $RPM_BUILD_ROOT
pushd build
make install DESTDIR=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_mingw32_bindir}
mv $RPM_BUILD_ROOT%{_mingw32_libdir}/libopenjpeg.dll $RPM_BUILD_ROOT%{_mingw32_bindir}
popd

# HACK: until pkg-config support lands, temporarily provide
# openjpeg.h header in legacy location
ln -s openjpeg/openjpeg.h $RPM_BUILD_ROOT%{_mingw32_includedir}/openjpeg.h


%check
# mostly pointless without test images, but it's a start -- Rex
make test -C build


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc license.txt
%{_mingw32_includedir}/openjpeg.h
%{_mingw32_includedir}/openjpeg
%{_mingw32_bindir}/libopenjpeg.dll
%{_mingw32_libdir}/libopenjpeg.dll.a


%changelog
* Mon Nov 16 2009 Adam Goode <adam@spicenitz.org> - 1.3-5
- Initial release, tracking Fedora native openjpeg-1.3-5
